package linkvalidator;

/*
Link Validator ralis par Laurent de Lasteyrie
Site web : www.hobbesworld.com
Page web : www.hobbesworld.com/linkvalidator/index.php
*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;
import java.io.*;
import java.text.*;

class Analyse extends Thread
{
  static JFrame fLv;
  static JButton bURL1;
  static BaseDonnees base;
  static String monURL;
  static JLabel lErreur;
  static JLabel lBon;

  static String monURLbase;
  static String fichATraiter;
  static String pathDirTraite;
  static String pathFichTraite;
  static String message;
  ToValidLink pathFichTraiteR;
  static String filePath;
  static int codeRetour, oImg, oPage, oTotal, oProg, nbOK, nbKO;
  static boolean optContenu, optLogDetail,optComment,optResume;
  static String logFileName;
  static String dateBaseLog, dateFileName;
  static ToValidLink tmpVL, tmpEL;

      Analyse(JFrame _fLv, JButton _bURL1, JLabel _lErreur, JLabel _lBon, BaseDonnees _base, String _monURL, boolean _oC, boolean _oLD, boolean _oCo,boolean _oR, String _lFN)
      {
        base=_base;
        monURL=_monURL;
        optContenu = _oC;
        optLogDetail=_oLD;
        optComment=_oCo;
        optResume=_oR;
        bURL1=_bURL1;
        fLv=_fLv;
        lErreur = _lErreur;
        lBon = _lBon;
        logFileName=_lFN;
        oImg=0;
        oPage=0;
        oTotal=0;
        oProg=0;
      }

      public void run()
      {
        int i,j,cmptLast;

        java.util.Date date = new java.util.Date(System.currentTimeMillis());
        SimpleDateFormat SDF1 = new SimpleDateFormat("dd-MM-yyyy", Locale.FRANCE);
        dateBaseLog = SDF1.format(date);
        SimpleDateFormat SDF2 = new SimpleDateFormat("yyyyMMdd", Locale.FRANCE);
        dateFileName = SDF2.format(date);
        
        nbKO = 0;
        nbOK = 0;

        base.toValidLink.table.clear();
        base.logValid.clear();
        cmptLast = 0;
        if (monURL.lastIndexOf("/") <= 8 ) {
          monURLbase = monURL;
        }
        else {
          monURLbase = monURL.substring(cmptLast,monURL.indexOf("/",8));
        }
          base.addLog("monURLbase : "+monURLbase);
          base.toValidLink = new ToValidLink(monURL, monURL, 2, monURL, base, optLogDetail, monURLbase, "");
          base.toValidLink.affichNom(0);
          base.omonURL = monURL;
          base.addLog("#############################################################");
          base.addLog("###                     LinkValidator                     ###");
          base.addLog("###                    HobbesWorld.com                    ###");
          base.addLog("#############################################################");
          base.addLog("Site : "+monURL);

          base.addLog("Date : "+dateBaseLog);

          base.addLog("\r\nTraitement\r\n");
          base.addLog("\r\n\r\n###############################\r\nListe des fichiers : \r\n");
          base.addLog("Fichier : "+monURL+" - (Premier fichier)");
          try {
            fichATraiter = recupURL(monURL);
          }
          catch (Exception erecup) {}
          if (fichATraiter != null) {
            extractURLFromFich(fichATraiter, base, monURL, monURL);
            while (base.toValidLink.table.size() > cmptLast) {
              pathFichTraiteR = base.toValidLink.selectId(cmptLast);
              pathFichTraite = pathFichTraiteR.fichier;
              fLv.setTitle(""+(cmptLast+1)+"/"+base.toValidLink.table.size()+" : "+pathFichTraite+" - Link Validator 1.02");
              if (optLogDetail || optContenu) {
                base.addLog("Fichier : "+pathFichTraite);
              }
              if ((pathFichTraiteR.cType == 1) && (pathFichTraite.indexOf(monURL) >= 0) && ((pathFichTraite.endsWith(".php")) || 
                  (pathFichTraite.endsWith(".html")) || (pathFichTraite.endsWith(".xhtml")) || (pathFichTraite.endsWith(".shtml"))
                  || (pathFichTraite.endsWith(".php4")) || (pathFichTraite.endsWith(".htm"))  || (pathFichTraite.endsWith(".php3"))
                  || (pathFichTraite.endsWith(".cfm")) || (pathFichTraite.endsWith(".asp")) || (pathFichTraite.endsWith(".xml")))) {
                try {
                  fichATraiter = recupURL(pathFichTraite);
                }
                catch (Exception erecup) {}
                pathDirTraite = pathFichTraite.substring(0,pathFichTraite.lastIndexOf("/"));
                extractURLFromFich(fichATraiter, base, pathDirTraite,pathFichTraite);
                base.toValidLink.modif(cmptLast,codeRetour);
                oPage = oPage+1;
                oTotal = oTotal+1;
              }
              else {
                try {
                  recupHeaderURL(pathFichTraite);
                }
                catch (Exception erecup) {}
                base.toValidLink.modif(cmptLast,codeRetour);
                if (pathFichTraite.endsWith(".zip") || pathFichTraite.endsWith(".exe") || pathFichTraite.endsWith(".rar") ||
                    pathFichTraite.endsWith(".arj")) {
                  oProg = oProg+1;
                }
                if (pathFichTraite.endsWith(".jpg") || pathFichTraite.endsWith(".jpeg") || pathFichTraite.endsWith(".gif")) {
                  oImg = oImg+1;
                }
                oTotal = oTotal+1;
              }
              if (codeRetour >= 400) {  nbKO = nbKO+1; }
              else { nbOK = nbOK+1; }
              lErreur.setText("KO : "+nbKO);
              lBon.setText("OK : "+nbOK);
              cmptLast++;
            }
          }
          base.addLog("fin du traitement");
          base.addLog("\r\n\r\n###############################\r\nStatistiques : ");
          base.addLog("Nombre de fichiers au total = "+oTotal);
          base.addLog("Nombre de pages = "+oPage);
          base.addLog("Nombre d'images = "+oImg);
          base.addLog("Nombre de programmes = "+oProg);
          base.addLog("Nombre de KO (code de retour >= 400) = "+nbKO);
          base.addLog("Nombre de OK (code de retour < 400) = "+nbOK);
          base.addLog("\r\n\r\nAttention, ceci n'est qu'un renseignement, certaines pages"); 
          base.addLog("s'affichent peut-tre en erreur alors que c'est le programme qui"); 
          base.addLog("a mal interprt le lien... ");
          if (optResume) {
                fLv.setTitle("Rsum... - Link Validator 1.02");
          base.addLog("\r\n\r\n###############################\r\nListe des parents pour un fichier : \r\n");
          for (i=0; i < base.toValidLink.table.size(); i++) {
            tmpVL = (ToValidLink) base.toValidLink.table.elementAt(i);
            base.addLog("Parent de : "+tmpVL.fichier+" ("+tmpVL.cRetour+"), fichier n "+i);
            if (tmpVL.cRetour >= 400) {
              for (j=0; j < tmpVL.listeParent.size(); j++) {
                tmpEL = (ToValidLink) tmpVL.listeParent.elementAt(j);
                base.addLog("   - "+tmpEL.fichier);
              }
            }
            else if (optComment) {
              for (j=0; j < tmpVL.listeParent.size(); j++) {
                tmpEL = (ToValidLink) tmpVL.listeParent.elementAt(j);
                base.addLog("   - "+tmpEL.fichier);
              }
            }
          }
          }
//        message = "Fin de l'analyse";
//        JOptionPane.showMessageDialog(null, message);
        base.saveLog(logFileName);
        bURL1.setEnabled(true);
        fLv.setTitle("Termin - Link Validator 1.02");
      }

  public static String recupURL (String URLtoGet) throws Exception {
    String totalFich = "";
    Integer cRInt;
    
    URL url = new URL (URLtoGet);
    URLConnection connectionURL = (URLConnection) url.openConnection();
    connectionURL.setRequestProperty("User-Agent", "Link Validator");
    connectionURL.connect();
    String codeRetourStr = connectionURL.getHeaderField(0);
    int i = codeRetourStr.indexOf(" ");
    cRInt = new Integer (codeRetourStr.substring(i+1,i+4));
    codeRetour = cRInt.intValue();
    if (optLogDetail) {
        base.addLog("  code retour : "+codeRetour);
    }
    if (codeRetour < 400) {
      filePath = url.getPath();
      BufferedReader fich = new BufferedReader (new InputStreamReader(connectionURL.getInputStream()));
      String ligne = fich.readLine();
      while (ligne!=null) {
        totalFich = totalFich+ligne;
        ligne = fich.readLine();
      }
      fich.close();
    }
    else {
          totalFich = "";
    }
    if (optContenu) {
      base.addLog(totalFich);
    }
    return totalFich;
  }

  public static void recupHeaderURL (String URLtoGet) throws Exception {
    Integer cRInt;
    
    URL url = new URL (URLtoGet);
    URLConnection connectionURL = (URLConnection) url.openConnection();
    connectionURL.setRequestProperty("User-Agent", "Link Validator");
    connectionURL.connect();
      
    String codeRetourStr = connectionURL.getHeaderField(0);
    int i = codeRetourStr.indexOf(" ");
    cRInt = new Integer (codeRetourStr.substring(i+1,i+4));
    codeRetour = cRInt.intValue();
    if (optLogDetail) {
      base.addLog(URLtoGet+" : "+codeRetour);
    }
  }

  public static void extractURLFromFich (String totalCP, BaseDonnees base, String fichOrig, String fichSource) {
        int i, j, k, tmpInt, i1,i2,i3,i4,i5;
        String tmpStr, totalFich, totalSFich;
        
        totalSFich = totalCP;
        totalFich = totalSFich.toLowerCase();
        i = totalFich.indexOf("http-equiv");
        if (i >=0 ) {
          tmpInt = i;
        tmpStr = totalFich.substring(tmpInt);
      i = tmpStr.indexOf("url=");
      if (i >= 0) {
                tmpInt = tmpInt+i+4;
                tmpStr = totalSFich.substring(tmpInt);
                tmpStr = tmpStr.substring(0,tmpStr.indexOf("\""));
        base.toValidLink = new ToValidLink(fichOrig, tmpStr, 1, monURL, base, optLogDetail, monURLbase, fichSource);
      }
    }
        totalSFich = totalCP;
        totalFich = totalSFich.toLowerCase();
        
        i1 = totalFich.indexOf(" href=");
        i2 = totalFich.indexOf("<div ");
        i3 = totalFich.indexOf(" src=");
        i4 = totalFich.indexOf(".src='");
        i5 = totalFich.indexOf("<frame ");
        j=0;
        while ((i1+i2+i3+i4+i5 > -5) && (j < 1000)) {
                j++;
                if ((((i1 < i2) || (i2 == -1)) && ((i1 < i3) || (i3 == -1)) && ((i1 < i4) || (i4 == -1)) && ((i1 < i5) || (i5 == -1))) && (i1 != -1)) {
                        i = i1;
                        tmpInt = i;
        tmpStr = totalSFich.substring(tmpInt+6);
                tmpStr = tmpStr.substring(0,tmpStr.indexOf(">"));
                if ((tmpStr.indexOf("javascript:") < 0) && (tmpStr.indexOf("mailto:") < 0) && (tmpStr.indexOf("#") < 2)
                     && (tmpStr.indexOf("<") < 0) && (tmpStr.indexOf(">") < 0)) {
                if (tmpStr.indexOf("\"") == 0) {
                  tmpStr = tmpStr.substring(1);
                  if (tmpStr.indexOf("\"") >= 0) {
                    tmpStr = tmpStr.substring(0,tmpStr.indexOf("\""));
                  }
            }
            else {
                k = tmpStr.indexOf(" ");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
                }
            }
                k = tmpStr.indexOf("?");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
              }
                k = tmpStr.indexOf("#");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
              }
          base.toValidLink = new ToValidLink(fichOrig, tmpStr, 1, monURL, base, optLogDetail, monURLbase, fichSource);
        }
            i1 = totalFich.indexOf(" href=",i1+5);
                }
                if ((((i2 < i1) || (i1 == -1)) && ((i2 < i3) || (i3 == -1)) && ((i2 < i4) || (i4 == -1)) && ((i2 < i5) || (i5 == -1))) && (i2 != -1)) {
                        i = i2;
        tmpInt = i;
        tmpStr = totalSFich.substring(tmpInt+3);
                tmpStr = tmpStr.substring(0,tmpStr.indexOf(">"));
                i = tmpStr.indexOf("src=");
            if (i >= 0) {
                tmpInt = i;
          tmpStr = tmpStr.substring(0,tmpInt+4);
                if ((tmpStr.indexOf("javascript:") < 0) && (tmpStr.indexOf("mailto:") < 0) && (tmpStr.indexOf("#") < 2)
                       && (tmpStr.indexOf("<") < 0) && (tmpStr.indexOf(">") < 0)) {
                  if (tmpStr.indexOf("\"") == 0) {
                    tmpStr = tmpStr.substring(1);
                  tmpStr = tmpStr.substring(0,tmpStr.indexOf("\""));
            }
            else {
                        k = tmpStr.indexOf(" ");
                if (k >= 0) {
                          tmpStr = tmpStr.substring(0,k);
                  }
            }
                k = tmpStr.indexOf("?");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
                }
                  k = tmpStr.indexOf("#");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
                }
            base.toValidLink = new ToValidLink(fichOrig, tmpStr, 1, monURL, base, optLogDetail, monURLbase, fichSource);
          }
        }
            i2 = totalFich.indexOf("<div ",i2+3);
          }
                if ((((i5 < i1) || (i1 == -1)) && ((i5 < i3) || (i3 == -1)) && ((i5 < i3) || (i3 == -1)) && ((i5 < i4) || (i4 == -1))) && (i5 != -1)) {
                        i = i5;
        tmpInt = i;
        tmpStr = totalSFich.substring(tmpInt+7);
                tmpStr = tmpStr.substring(0,tmpStr.indexOf(">"));
                i = tmpStr.indexOf("src=");
            if (i >= 0) {
                tmpInt = i;
          tmpStr = tmpStr.substring(tmpInt+4);
                if ((tmpStr.indexOf("javascript:") < 0) && (tmpStr.indexOf("mailto:") < 0) && (tmpStr.indexOf("#") < 2)
                       && (tmpStr.indexOf("<") < 0) && (tmpStr.indexOf(">") < 0)) {
                  if (tmpStr.indexOf("\"") == 0) {
                    tmpStr = tmpStr.substring(1);
                  tmpStr = tmpStr.substring(0,tmpStr.indexOf("\""));
            }
            else {
                        k = tmpStr.indexOf(" ");
                if (k >= 0) {
                          tmpStr = tmpStr.substring(0,k);
                  }
            }
                k = tmpStr.indexOf("?");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
                }
                  k = tmpStr.indexOf("#");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
                }
            base.toValidLink = new ToValidLink(fichOrig, tmpStr, 1, monURL, base, optLogDetail, monURLbase, fichSource);
          }
        }
            i5 = totalFich.indexOf("<frame ",i5+7);
          }
                if ((((i3 < i1) || (i1 == -1)) && ((i3 < i2) || (i2 == -1)) && ((i3 < i4) || (i4 == -1)) && ((i3 < i5) || (i5 == -1))) && (i3 != -1)) {
                        i = i3;
        tmpInt = i;
        tmpStr = totalSFich.substring(tmpInt+5);
                tmpStr = tmpStr.substring(0,tmpStr.indexOf(">"));
                if ((tmpStr.indexOf("javascript:") < 0) && (tmpStr.indexOf("mailto:") < 0) && (tmpStr.indexOf("#") < 2)
                     && (tmpStr.indexOf("<") < 0) && (tmpStr.indexOf(">") < 0)) {
                if (tmpStr.indexOf("\"") == 0) {
                  tmpStr = tmpStr.substring(1);
                  tmpStr = tmpStr.substring(0,tmpStr.indexOf("\""));
            }
            else {
                k = tmpStr.indexOf(" ");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
                }
            }
                k = tmpStr.indexOf("?");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
              }
                k = tmpStr.indexOf("#");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
              }
            
          base.toValidLink = new ToValidLink(fichOrig, tmpStr, 2, monURL, base, optLogDetail, monURLbase, fichSource);
        }
            i3 = totalFich.indexOf(" src=",i3+5);
          }
                if ((((i4 < i1) || (i1 == -1)) && ((i4 < i2) || (i2 == -1)) && ((i4 < i3) || (i3 == -1)) && ((i4 < i5) || (i5 == -1))) && (i4 != -1)) {
                        i = i4;
        tmpInt = i;
        tmpStr = totalSFich.substring(tmpInt+6);
                tmpStr = tmpStr.substring(0,tmpStr.indexOf("'"));
                k = tmpStr.indexOf("?");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
              }
                k = tmpStr.indexOf("#");
                if (k >= 0) {
                  tmpStr = tmpStr.substring(0,k);
              }
//        base.addLog(fichOrig+" "+tmpStr+" "+monURL+" "+base+" "+monURLbase+" "+fichSource);
        base.toValidLink = new ToValidLink(fichOrig, tmpStr, 2, monURL, base, optLogDetail, monURLbase, fichSource);
            i4 = totalFich.indexOf(".src='",i4+5);
      }
        }
  }
}

public class Lv {
  static JFrame fLv;
  static JLabel lErreur;
  static JLabel lBon;
  static BaseDonnees base;
  static JTextField tfURL1,tfProxy1,tfProxy2,tfFileName1;
  static JLabel lURL1;
  static String monURL;
  static String optionPath;
  static JButton bURL1;
  static JCheckBox cbSaveOption;
  static boolean optContenu, optLogDetail,optComment,optResume;
  static String logFileName;
    
  public static void main ( String[] args ) throws Exception {
    try  {
      UIManager.setLookAndFeel(new com.sun.java.swing.plaf.windows.WindowsLookAndFeel());
    }
    catch (Exception e) {
    }
    fLv = new JFrame("Link Validator 1.02");
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    fLv.setSize(new Dimension(screenSize.width / 2, screenSize.height / 2));
    
    
    fLv.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        if (cbSaveOption.isSelected()) {
          base.saveOptions(optionPath);
        }
        base.saveLog(logFileName);
        System.exit(0);
      }
    });

    base = new BaseDonnees();
    final JPanel pURL = new JPanel();
    JPanel pListBox = new JPanel();
    JPanel pLog = new JPanel();
    JPanel pCheckBox = new JPanel();
    JPanel pInfoDiv = new JPanel();


    String pathDir = (String) System.getProperty("user.dir");

    String osname = (String) System.getProperty("os.name");
    if (osname.indexOf("indows") > 0) {
        if (pathDir.lastIndexOf("\\") != pathDir.length()-1) {
                pathDir = pathDir+"\\";
        }
    }
    else {
        if (pathDir.lastIndexOf("/") != pathDir.length()-1) {
                pathDir = pathDir+"/";
        }
    }
    optionPath = pathDir+"linkvalidator/option.ini";
    base.loadOptions(optionPath,pathDir);

    lURL1 = new JLabel("URL  tester : ");
    tfURL1 = new JTextField(base.omonURL);
    tfURL1.setPreferredSize(new Dimension(230,20));
    cbSaveOption = new JCheckBox("Sauvegarder les paramtres");
    final JCheckBox cbProxy1 = new JCheckBox("J'utilise un proxy",(base.oProxyCB.indexOf("OK") == 0));
    JLabel lProxy1 = new JLabel("Nom du proxy : ");
    tfProxy1 = new JTextField(base.oProxyIP);
    tfProxy1.setPreferredSize(new Dimension(120,20));
    JLabel lProxy2 = new JLabel("Port du proxy : ");
    tfProxy2 = new JTextField(base.oProxyPort);
    tfProxy2.setPreferredSize(new Dimension(30,20));

    JLabel lFileName1 = new JLabel("Chemin d'accs :");
    tfFileName1 = new JTextField(base.oLogFileName);
    tfFileName1.setPreferredSize(new Dimension(230,20));
    JLabel lOption1 = new JLabel("Prsence dans le fichier de log de :");
    final JCheckBox cbLogContenu = new JCheckBox("contenu des fichiers",(base.oOptionContenu.indexOf("OK") == 0));
    final JCheckBox cbLogComment = new JCheckBox("commentaires",(base.oOptionComment.indexOf("OK") == 0));
    final JCheckBox cbLogResume = new JCheckBox("rsum",(base.oOptionResume.indexOf("OK") == 0));
    final JCheckBox cbLogDetail = new JCheckBox("liens pour chaque page",(base.oOptionDetail.indexOf("OK") == 0));
    
    bURL1 = new JButton("  Action   ");
    bURL1.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
                fLv.setTitle("En cours... - Link Validator 1.02");
                bURL1.setEnabled(false);
          monURL = tfURL1.getText();
          if (monURL.lastIndexOf("/") == monURL.length()-1) {
                  monURL = monURL.substring(0,monURL.length()-1);
          }
        optContenu = cbLogContenu.isSelected();
        if (optContenu) {
                base.oOptionContenu = "OK";
        }
        else {
                base.oOptionContenu = "NO";
        }
        optComment = cbLogComment.isSelected();
        if (optComment) {
                base.oOptionComment = "OK";
        }
        else {
                base.oOptionComment = "NO";
        }
        optResume = cbLogResume.isSelected();
        if (optResume) {
                base.oOptionResume = "OK";
        }
        else {
                base.oOptionResume = "NO";
        }
        logFileName = tfFileName1.getText();
          base.oLogFileName = logFileName;
        optLogDetail = cbLogDetail.isSelected();
        if (optLogDetail) {
                base.oOptionDetail = "OK";
        }
        else {
                base.oOptionDetail = "NO";
        }
        if (cbSaveOption.isSelected()) {
          base.saveOptions(optionPath);
        }
          if (cbProxy1.isSelected()) {
                base.oProxyCB = "OK";
          base.addLog("utilisation du serveur Proxy");
            String monProxy = tfProxy1.getText();
            String monPort = tfProxy2.getText();
          base.oProxyIP = monProxy;
          base.oProxyPort = monPort;
          System.getProperties().put( "proxySet", "true" );
          System.getProperties().put( "proxyHost", monProxy );
          System.getProperties().put( "proxyPort", monPort );
        }
        else {
                base.oProxyCB = "NO";
          System.getProperties().put( "proxySet", "false" );
        }
                new Analyse(fLv, bURL1, lErreur, lBon, base,monURL,optContenu, optLogDetail,optComment,optResume,logFileName).start();
        }
    });
    
//    pURL.setLayout(new BoxLayout(pURL,BoxLayout.Y_AXIS));
    pURL.add(lURL1,BorderLayout.NORTH);
    pURL.add(tfURL1,BorderLayout.CENTER);
    pURL.add(bURL1,BorderLayout.SOUTH);
    pURL.add(cbSaveOption,BorderLayout.SOUTH);
        
    pListBox.add(cbProxy1,BorderLayout.SOUTH);
    pListBox.add(lProxy1,BorderLayout.NORTH);
    pListBox.add(tfProxy1,BorderLayout.CENTER);
    pListBox.add(lProxy2,BorderLayout.NORTH);
    pListBox.add(tfProxy2,BorderLayout.CENTER);
    
    pCheckBox.setLayout(new BoxLayout(pCheckBox,BoxLayout.Y_AXIS));
    pCheckBox.add (lFileName1,BorderLayout.WEST);
    pCheckBox.add (tfFileName1,BorderLayout.WEST);
    pCheckBox.add (lOption1,BorderLayout.WEST);
    pCheckBox.add (cbLogContenu,BorderLayout.WEST);
    pCheckBox.add (cbLogResume,BorderLayout.WEST);
    pCheckBox.add (cbLogComment,BorderLayout.WEST);
    pCheckBox.add (cbLogDetail,BorderLayout.WEST);
    
    lErreur = new JLabel("KO : ");
    lBon = new JLabel("OK : ");

    pInfoDiv.setLayout(new BoxLayout(pInfoDiv,BoxLayout.Y_AXIS));
    pInfoDiv.add (lErreur,BorderLayout.WEST);
    pInfoDiv.add (lBon,BorderLayout.WEST);

    pLog.setLayout(new BoxLayout(pLog,BoxLayout.X_AXIS));
    pLog.add(pCheckBox,null);
    pLog.add(pInfoDiv,null);

//    fLv.getContentPane().setLayout(new BoxLayout(fLv.getContentPane(),BoxLayout.Y_AXIS));


    fLv.getContentPane().add("North",pURL);
    fLv.getContentPane().add("Center",pListBox);
    fLv.getContentPane().add("South",pLog);

    fLv.pack();
    fLv.setVisible(true);
    
  }
  
}
