package linkvalidator;

/*
Link Validator ralis par Laurent de Lasteyrie
Site web : www.hobbesworld.com
Page web : www.hobbesworld.com/linkvalidator/index.php
*/

import java.io.*;
import java.util.*;
import java.lang.*;
import java.util.Vector;

public class ToValidLink implements Serializable {
  int cType;
  int cRetour;
  String fichier;
  Vector listeParent;
  static Vector table = new Vector();
  static boolean ajout;
  static int dernier;
  static String fichAjout;

  public ToValidLink (String RepOrig, String oFichier, int cCType, String URLSite, BaseDonnees base, boolean optLogDetail, String URLbase, String fSource) {
    String fichOrig, cFichier;
    ToValidLink resultat;
    boolean ajout;
    int i;
    
    ToValidLink tmpVL, tmpEL;

    ajout = false;
    fichOrig = RepOrig;
    cFichier = oFichier;
    if ((cFichier.indexOf("://") >= 0) || (cFichier.indexOf(">") >= 0) || (cFichier.indexOf("<") >= 0)) {
      fichier = cFichier;
    }
    else {
      if (cFichier.indexOf("/") == 0) {
        cFichier = cFichier.substring(1);
        fichOrig = URLbase;
      }
      while (cFichier.indexOf("../") >= 0) {
        cFichier = cFichier.substring(cFichier.indexOf("../")+3);
        fichOrig = fichOrig.substring(0,fichOrig.lastIndexOf("/"));
      }
      if (cFichier.indexOf("./") >= 0) {
        cFichier = cFichier.substring(cFichier.indexOf("./")+2);
      }
      fichier = fichOrig+"/"+cFichier;
    }
    tmpVL = ToValidLink.select(fichier);
    if (tmpVL == null) {
      cType = cCType;
      table.addElement(this);
      this.listeParent = new Vector();
      tmpEL = ToValidLink.select(fSource);
      if (tmpEL != null) {
        this.listeParent.addElement(ToValidLink.select(fSource));
      }
/*      else {
        base.addLog("Probleme : "+fSource);
      }*/
      if (optLogDetail) {
        base.addLog("   "+RepOrig+" - "+oFichier+" : "+fichier);
      }
      fichAjout = fichier;
      ajout = true;
    }
    else {
      ajout = true;
      for (i=0; i<tmpVL.listeParent.size(); i++) {
        resultat = (ToValidLink) tmpVL.listeParent.elementAt(i);
        if (resultat.fichier.equals(fSource)) {
          ajout = false;
        }
      }
      if (ajout) {
        tmpVL.listeParent.addElement(ToValidLink.select(fSource));
      }
    }
  }
        
  static ToValidLink select (String searchFile) {
    ToValidLink resultat;
    int i;
                
    for (i=0; i<table.size(); i++) {
      resultat = (ToValidLink)table.elementAt(i);
      if (resultat.fichier.equals(searchFile)) {
        return resultat;
      }
    }
    return null;
  }

  static void affich () {
    ToValidLink resultat;
    int i;
                
    for (i=0; i<table.size(); i++) {
      resultat = (ToValidLink)table.elementAt(i);
    }
  }

  static ToValidLink selectId (int i) {
    ToValidLink resultat;
                
    resultat = (ToValidLink)table.elementAt(i);
    return resultat;
  }

  static String affichNom (int i) {
    ToValidLink resultat;
                
    resultat = (ToValidLink)table.elementAt(i);
    return resultat.fichier;
  }

  static void modif (int i, int codeRetour) {
    ToValidLink resultat;
                
    resultat = (ToValidLink)table.elementAt(i);
    resultat.cRetour = codeRetour;
    dernier++;
  }
}